-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

-- Prep the module
local M = {}
M.type = "auxilliary"
M.relevantDevice = nil
M.defaultOrder = 11000

-- Debug stuff
local ugfxCalled = 0

-- Dispenser nodes
local nFtop = nil
local nFbtm = nil

-- Particle emission timing
local canDispense = 0
local dispenseTimer = 0
local dispenseInterval = 0.0333

-- Graphics update function; Updates other stuff too according to dt
local function updateGFX(dt)
	
	local NowUnloading = (electrics.values.unload or 0)
	if (NowUnloading ~= 1) or (canDispense ~= 1) then
		electrics.values.dispenser_chute_active = 0
	end
	local DispenserActive = (electrics.values.dispenser_chute_active or 0)
	
	-- Do dispensing stuff
	if DispenserActive == 1 then
		
		-- Advance burn time
		dispenseTimer = dispenseTimer + dt
		
		-- Time to generate particles
		if dispenseTimer >= dispenseInterval then
			dispenseTimer = 0
			-- obj:addParticleByNodesRelative(	node1,	node2,	speed,	type,	width,	count)
			obj:addParticleByNodesRelative(		nFtop,	nFbtm,	10,		5,		0.1,	20)
		end
	end
	
	-- Debug message
	if ugfxCalled == 0 then
		ugfxCalled = 1
		log("I", "HB9K Dispenser Chute", "updateGFX called")
	end
end

-- Reset what we need to
local function reset()
	log("I", "HB9K Dispenser Chute", "reset called")
	electrics.values['dispenser_chute_active'] = 0
	dispenseTimer = 0
end

-- Initialize everything, except sounds
local function init(jbeamdata)
	log("I", "HB9K Man Dispenser Chute", "init called")
	
	-- Get emitter nodes
	nFtop = jbeamdata.topCtrNode
	nFbtm = jbeamdata.btmCtrNode
	
	--Can't dispense without both nodes
	if nFbtm ~= nil and nFtop ~= nil then canDispense = 1 end
end

-- Public interface
M.init = init
--M.initSounds = initSounds
M.reset = reset
M.updateGFX = updateGFX

-- Return the module
return M
