-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

-- Prep the module
local M = {}
M.type = "auxilliary"
M.relevantDevice = nil
M.defaultOrder = 11000

-- Debug stuff
local ugfxCalled = 0

-- Welder nodes
local nFtop = nil
local nFbtm = nil

-- Particle emission timing
local canWeld = 0
local sparkTimer = 0
local sparkInterval = 0.0333

-- Graphics update function; Updates other stuff too according to dt
local function updateGFX(dt)
	
	local WelderActive = (electrics.values.welder_active or 0)
	
	-- Do weld stuff
	if (WelderActive == 1) and (canWeld == 1) then
		
		-- Advance weld time
		sparkTimer = sparkTimer + dt
		
		-- Time to generate particles
		if sparkTimer >= sparkInterval then
			sparkTimer = 0
			-- obj:addParticleByNodesRelative(	node1,	node2,	speed,	type,	width,	count)
			obj:addParticleByNodesRelative(		nFbtm,	nFtop,	0,		9,		0.1,	20)
		end
	end
	
	-- Debug message
	if ugfxCalled == 0 then
		ugfxCalled = 1
		log("I", "HB9K Man Welder", "updateGFX called")
	end
end

-- Reset what we need to
local function reset()
	log("I", "HB9K Man Welder", "reset called")
	electrics.values['welder_active'] = 0
	sparkTimer = 0
end

-- Initialize everything, except sounds
local function init(jbeamdata)
	log("I", "HB9K Man Welder", "init called")
	
	-- Get emitter nodes
	if true then
		nFtop = jbeamdata.topCtrNode
		nFbtm = jbeamdata.btmCtrNode
	else
		for k, node in pairs (v.data.nodes) do
			if node.name == "pfgbm3ex74" then nFbtm = k elseif
			   node.name == "pfgbm3ex7_s1" then nFtop = k end
		end
	end
	
	--Can't fire without both nodes
	if nFbtm ~= nil and nFtop ~= nil then canWeld = 1 end
end

-- Public interface
M.init = init
--M.initSounds = initSounds
M.reset = reset
M.updateGFX = updateGFX

-- Return the module
return M
